// DirectPlayDlg.cpp : Implementation of CDirectPlayDlg
#include "stdafx.h"
#include "DirectPlayDlg.h"
#include "DlgAbout.h"
#include "Directplay Service_i.c"

#include <windowsx.h>

// constants
const DWORD	MAXSTRLEN		= 200;		// max size of a temporary string
const UINT	TIMERID			= 1;		// timer ID to use
const UINT	TIMERINTERVAL	= 200;		// timer interval
/////////////////////////////////////////////////////////////////////////////
// Cdilgdirect

	static LPDIRECTPLAY3A	lpDirectPlay3A;
	static UINT				idTimer;
	HRESULT					hr;
	LPVOID					lpConnection = NULL;

BOOL FAR PASCAL DirectPlayEnumConnectionsCallback(LPCGUID lpguidSP,
						LPVOID lpConnection, DWORD dwConnectionSize,
						LPCDPNAME lpName, DWORD dwFlags, LPVOID lpContext);
BOOL FAR PASCAL EnumSessionsCallback(LPCDPSESSIONDESC2 lpSessionDesc,
					LPDWORD	lpdwTimeOut, DWORD dwFlags,	LPVOID lpContext);

LRESULT CDirectPlayDlg::OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	static LPDIRECTPLAY3A	lpDirectPlay3A;
	HRESULT					hr;
   	LPVOID lpContext = (LPVOID) m_hWnd;	

	lpDirectPlay3A = NULL;

	// Create an IDirectPlay3 interface
	hr = CreateDirectPlayInterface(&lpDirectPlay3A);
	if (FAILED(hr))
		goto SP_FAILURE;

	// set first item in the connections combo box
	SendDlgItemMessage(IDC_SPCOMBO, CB_ADDSTRING, (WPARAM) 0, (LPARAM) "<Select a service provider>");
	SendDlgItemMessage(IDC_SPCOMBO, CB_SETITEMDATA, (WPARAM) 0, (LPARAM) 0);
	SendDlgItemMessage(IDC_SPCOMBO, CB_SETCURSEL, (WPARAM) 0, (LPARAM) 0);


	// put all the available connections in a combo box
	lpDirectPlay3A->EnumConnections(&LIBID_DIRECTPLAYSERVICELib, DirectPlayEnumConnectionsCallback, lpContext,0);//hWnd, 0);
	goto br;

SP_FAILURE:
	MessageBox("This application requires DirectX 5 or later.", _T("ATL DirectPlay Service"), MB_OK);
	EndDialog(FALSE);
br:		
	return 1;  // Let the system set the focus
}

LRESULT CDirectPlayDlg::OnContextMenu(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
// TODO : Add Code for message handler. Call DefWindowProc if necessary.
	return 0;
}

LRESULT CDirectPlayDlg::OnCancel(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
		KillTimer(idTimer ); 
		// delete any interface created if cancelling
		hr = DestroyDirectPlayInterface(hWndCtl, lpDirectPlay3A);
		lpDirectPlay3A = NULL;
		
		EndDialog(wID);
		return 0;
}

LRESULT CDirectPlayDlg::OnSelchangeSpcombo(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{

 		// service provider changed, so rebuild display and
		// delete any existing DirectPlay interface
		KillTimer(idTimer ); 
		hr = DestroyDirectPlayInterface(hWndCtl, lpDirectPlay3A);
		lpDirectPlay3A = NULL;

		// get pointer to the selected connection
		hr = GetConnection(hWndCtl, &lpConnection);
		if FAILED(hr)
			goto SP_FAILURE;

			if (lpConnection)
			{
				// Create a new DirectPlay interface.
			
				hr = CreateDirectPlayInterface( &lpDirectPlay3A );

				if ((FAILED(hr)) || (NULL == lpDirectPlay3A))
					goto SP_FAILURE;

				// initialize the connection
				hr = lpDirectPlay3A->InitializeConnection(lpConnection, 0);
				if FAILED(hr)
					goto SP_FAILURE;

				// start enumerating the sessions
				hr = EnumSessions(hWndCtl, lpDirectPlay3A);
				if FAILED(hr)
					goto SP_FAILURE;

				// set a timer to refresh the session list
				idTimer = SetTimer(TIMERID, TIMERINTERVAL);
			}

			goto br;


	SP_FAILURE:
		if (hr != DPERR_USERCANCEL)
			ErrorBox("Could not select service provider because of error 0x%08X", hr);

br:
	// TODO : Add Code for control notification handler.
	return 0;
}

LRESULT CDirectPlayDlg::OnDestroy(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	// delete information stored along with the lists
	DeleteConnectionList(m_hWnd);
	lpDirectPlay3A = NULL;
	// TODO : Add Code for message handler. Call DefWindowProc if necessary.
	return 0;
}
LRESULT CDirectPlayDlg::OnTimer(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	// refresh the session list
	hr = EnumSessions(m_hWnd, lpDirectPlay3A);
	// TODO : Add Code for message handler. Call DefWindowProc if necessary.
	return 0;
}

BOOL FAR PASCAL DirectPlayEnumConnectionsCallback(LPCGUID lpguidSP,
						LPVOID lpConnection, DWORD dwConnectionSize,
						LPCDPNAME lpName, DWORD dwFlags, LPVOID lpContext)
{

    HWND			hWnd = (HWND) lpContext;
    LRESULT			iIndex;
	LPVOID			lpConnectionBuffer;

	// store service provider name in combo box
	iIndex = SendDlgItemMessage(hWnd, IDC_SPCOMBO, CB_ADDSTRING, 0, 
									(LPARAM) lpName->lpszShortNameA);
	if (iIndex == CB_ERR)
		goto FAILURE;

	// make space for connection shortcut
	lpConnectionBuffer = GlobalAllocPtr(GHND, dwConnectionSize);
	if (lpConnectionBuffer == NULL)
		goto FAILURE;

	// store pointer to connection shortcut in combo box
	memcpy(lpConnectionBuffer, lpConnection, dwConnectionSize);
	SendDlgItemMessage(hWnd, IDC_SPCOMBO, CB_SETITEMDATA, (WPARAM) iIndex, 
									(LPARAM) lpConnectionBuffer);

FAILURE:
    return (TRUE);
}


HRESULT CDirectPlayDlg::CreateDirectPlayInterface( LPDIRECTPLAY3A *lplpDirectPlay3A )
{
	HRESULT				hr;
	LPDIRECTPLAY3A		lpDirectPlay3A = NULL;

	// Create an IDirectPlay3 interface
	hr = CoCreateInstance(	CLSID_DirectPlay, NULL, CLSCTX_INPROC_SERVER, 
		IID_IDirectPlay3A, (LPVOID*)&lpDirectPlay3A);

	// return interface created
	*lplpDirectPlay3A = lpDirectPlay3A;

	return (hr);
}

void CDirectPlayDlg::DeleteConnectionList(HWND hWnd)
{
	WPARAM	i;
	LONG	lpData;
	
	// destroy the GUID's stored with each service provider name
	i = 0;
	while (TRUE)
	{
		// get data pointer stored with item
		lpData = SendDlgItemMessage(IDC_SPCOMBO, CB_GETITEMDATA,
									(WPARAM) i, (LPARAM) 0);
		if (lpData == CB_ERR)		// error getting data
			break;

		if (lpData != 0)			// no data to delete
			GlobalFreePtr((LPVOID) lpData);

		i += 1;
	}

	// delete all items in combo box
	SendDlgItemMessage(IDC_SPCOMBO, CB_RESETCONTENT,
								(WPARAM) 0, (LPARAM) 0);
}

HRESULT CDirectPlayDlg::DestroyDirectPlayInterface(HWND hWnd, LPDIRECTPLAY3A lpDirectPlay3A)
{
	HRESULT		hr = DP_OK;

	if (lpDirectPlay3A)
		hr = lpDirectPlay3A->Release();

	return (hr);
}

HRESULT CDirectPlayDlg::GetConnection(HWND hWnd, LPVOID *lplpConnection)
{
	LONG	iIndex;

	// get index of the item currently selected in the combobox
	iIndex = SendDlgItemMessage(IDC_SPCOMBO, CB_GETCURSEL,
								(WPARAM) 0, (LPARAM) 0);
	if (iIndex == CB_ERR)
		return (DPERR_GENERIC);

	// get the pointer to the connection shortcut associated with
	// the item
	iIndex = SendDlgItemMessage(IDC_SPCOMBO, CB_GETITEMDATA,
								(WPARAM) iIndex, (LPARAM) 0);
	if (iIndex == CB_ERR)
		return (DPERR_GENERIC);

	*lplpConnection = (LPVOID) iIndex;

	return (DP_OK);
}

HRESULT CDirectPlayDlg::EnumSessions(HWND hWnd, LPDIRECTPLAY3A lpDirectPlay3A)
{
	DPSESSIONDESC2	sessionDesc;
	GUID			guidSessionInstance;
	HRESULT			hr;

	// check for valid interface
	if (lpDirectPlay3A == NULL)
		return (DPERR_INVALIDOBJECT);

	// get guid of currently selected session
	guidSessionInstance = GUID_NULL;

	// add sessions to session list
	ZeroMemory(&sessionDesc, sizeof(DPSESSIONDESC2));
	sessionDesc.dwSize = sizeof(DPSESSIONDESC2);
    sessionDesc.guidApplication = LIBID_DIRECTPLAYSERVICELib;

	hr = lpDirectPlay3A->EnumSessions(&sessionDesc, 0, EnumSessionsCallback,
									  hWnd, DPENUMSESSIONS_AVAILABLE | DPENUMSESSIONS_ASYNC);
	return (hr);
}

BOOL FAR PASCAL EnumSessionsCallback(LPCDPSESSIONDESC2 lpSessionDesc,
					LPDWORD	lpdwTimeOut, DWORD dwFlags,	LPVOID lpContext)
{
	LPGUID			lpGuid;

	// see if last session has been enumerated
    if (dwFlags & DPESC_TIMEDOUT)
		return (FALSE);						

	// make space for session instance guid
	lpGuid = (LPGUID) GlobalAllocPtr( GHND, sizeof(GUID) );
	if (lpGuid == NULL)
		goto FAILURE;

	// store pointer to guid in list
	*lpGuid = lpSessionDesc->guidInstance;

FAILURE:
    return (TRUE);
}

void CDirectPlayDlg::ErrorBox(LPSTR lpszErrorStr, HRESULT hr)
{
	char	szStr[MAXSTRLEN];

	wsprintf(szStr, lpszErrorStr, hr);

	MessageBox(szStr, "chucriError", MB_OK);
}

LRESULT CDirectPlayDlg::OnClickedAbout(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	// create the modeless dialog, originally hidden
	CDlgAbout* pDlgA = new CDlgAbout;
	if (!pDlgA->DoModal())
	{
		delete pDlgA;
		return FALSE;
	}
	// TODO : Add Code for control notification handler.
	return 0;
}

